# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Wed Jul  6 10:16:56 2022
#  Target Database = postgresql
#
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_audit.db.tables.aud_key import tAudKey
from bs_audit.db.tables.aud import tAud

class dAudSelectOne:

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tAudKey()
        self.orec     = None
    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  id: int) -> "dAudSelectOne":
        """
        Execute the query by setting all the inputs.

        :param id: int
        :return: Self for convenience.
        """
        self.irec.id = id

        return self.exec()

    def exec(self, irec: tAudKey = None) -> "dAudSelectOne":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("AudSelectOne", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  id,
  tran_id,
  action,
  tbl_id,
  tbl_key
from
  audit.Aud
where
  id = :id""")

        self._dbstmnt.bind_in("id", self.irec.id, int, 8)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("tran_id", int, 8)
        self._dbstmnt.bind_out("action", str, 1)
        self._dbstmnt.bind_out("tbl_id", str)
        self._dbstmnt.bind_out("tbl_key", str)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec = tAud()

        self.orec.id = self._dbstmnt.result[0]
        self.orec.tran_id = self._dbstmnt.result[1]
        self.orec.action = self._dbstmnt.result[2]
        self.orec.tbl_id = self._dbstmnt.result[3]
        self.orec.tbl_key = self._dbstmnt.result[4]

        return True

    def fetch_iter(self) -> tAud:
        """
        Yield all the rows one at a time.

        :return: Iterator for output rows
        """
        while self.fetch():
            yield self.orec

    def fetch_all(self, out_list: tAud.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            out_list.clear()

        while self.fetch():
            out_list.append(self.orec)

        return len(out_list)

